
/**
 * temperature reading
 *
 * @author matecsaba
 */
public class temperData {

    /**
     * my number
     */
    protected final int myNum;

    /**
     * my name
     */
    protected final String myNam;

    /**
     * last measured temperature
     */
    protected int lastMeasure;

    /**
     * time measured temperature
     */
    protected long timeMeasure;

    /**
     * time window temperature
     */
    protected long timeWindow;

    /**
     * last window temperature
     */
    protected int lastWindow;

    /**
     * last works status
     */
    protected boolean isWorking;

    /**
     * last tilted status
     */
    protected boolean isWindow;

    /**
     * last calculated value
     */
    protected int lastCalc;

    /**
     * create instance
     *
     * @param num my number
     * @param nam my name
     */
    protected temperData(int num, String nam) {
        myNum = num;
        myNam = nam;
        lastMeasure = 20;
        lastWindow = lastMeasure;
    }

    /**
     * get current measurement
     */
    protected synchronized void getValue() {
        try {
            Runtime rtm = Runtime.getRuntime();
            String[] cmd = new String[1];
            cmd[0] = "./tempget" + myNum + ".sh";
            Process prc = rtm.exec(cmd);
            prc.waitFor();
            int i = prc.exitValue();
            if (i < 1) {
                return;
            }
            if (i < (lastMeasure - 10)) {
                return;
            }
            lastMeasure = i;
            timeMeasure = temperUtil.getTime();
        } catch (Exception e) {
        }
    }

    /**
     * update window
     */
    protected void setWindow() {
        lastWindow = lastMeasure;
    }

    /**
     * calculate
     *
     * @param cl parent
     */
    protected void doCalc(temper cl) {
        isWorking = true;
        isWindow = false;
        long tim = temperUtil.getTime();
        lastCalc = cl.currValue & 1;
        int old = lastCalc;
        if (cl.lastNeeded > lastMeasure) {
            lastCalc = 1;
        }
        if (cl.lastNeeded < lastMeasure) {
            lastCalc = 0;
        }
        if ((tim - timeMeasure) > (5 * 60 * 1000)) {
            isWorking = false;
            lastCalc = 0;
            return;
        }
        if (timeWindow > 0) {
            isWindow = true;
            if (lastMeasure < lastWindow) {
                lastWindow = lastMeasure;
                timeWindow = tim;
            }
            if (lastMeasure > lastWindow) {
                timeWindow = 0;
            }
            if ((tim - timeWindow) > (30 * 60 * 1000)) {
                timeWindow = 0;
            }
            lastCalc = 0;
        }
        if ((old == 1) && (lastMeasure < lastWindow)) {
            isWindow = true;
            timeWindow = tim;
            lastCalc = 0;
        }
        if (old == 1) {
            lastWindow = lastMeasure;
        }
    }

    /**
     * get log line
     *
     * @return string
     */
    public String getLog() {
        return timeMeasure + ";" + timeWindow + ";" + lastWindow + ";" + lastMeasure + ";" + isWorking + ";" + isWindow;
    }

    /**
     * get web line
     *
     * @return string
     */
    public String getMeas() {
        return "measured #" + myNum + "-" + myNam + ": " + lastMeasure + " celsius, " + temperUtil.timePast(temperUtil.getTime(), timeMeasure) + " ago";
    }

    /**
     * get web error
     *
     * @return string
     */
    public String getWindow() {
        if (!isWindow) {
            return null;
        }
        return "window #" + myNum + ": " + lastWindow + " celsius, " + temperUtil.timePast(temperUtil.getTime(), timeWindow) + " ago";
    }

}
